"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.selectAll = selectAll;

var _document = require("../../document");

var _isContentEditable = require("../edit/isContentEditable");

var _isEditable = require("../edit/isEditable");

var _isElementType = require("../misc/isElementType");

var _selection = require("./selection");

/**
 * Expand a selection like the browser does when pressing Ctrl+A.
 */
function selectAll(target) {
  var _getContentEditable;

  if ((0, _isElementType.isElementType)(target, 'textarea') || (0, _isElementType.isElementType)(target, 'input') && target.type in _isEditable.editableInputTypes) {
    return (0, _selection.setSelection)({
      focusNode: target,
      anchorOffset: 0,
      focusOffset: (0, _document.getUIValue)(target).length
    });
  }

  const focusNode = (_getContentEditable = (0, _isContentEditable.getContentEditable)(target)) != null ? _getContentEditable : target.ownerDocument.body;
  (0, _selection.setSelection)({
    focusNode,
    anchorOffset: 0,
    focusOffset: focusNode.childNodes.length
  });
}